if (TCATADSAMS_LIBRARIES AND TCATADSAMS_INCLUDE_DIRS)
    set(TCATADSAMS_FOUND TRUE)

else()
    if (TWINCATSDK AND (EXISTS ${TWINCATSDK}/Include))
        set(TWINCATSDK_INCLUDE "${TWINCATSDK}/Include")
    endif()

    find_path(TCATADSAMS_INCLUDE_DIR
        NAMES
            TcAdsDef.h TcAdsAPI.h
        HINTS
            ${TCATADSAMS_INCDIR}
            $ENV{TCATADSAMS_INCDIR}
        PATHS
            /usr/include
	        /opt/include
	        /usr/local/include
	        /opt/local/include
            ${TWINCATSDK_INCLUDE}
    )

    if(WIN32)


    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(TCATADSAMSU14_NUGET_BIN ${TCATADSAMS_NUGET_PATH}/bin/x64)
        set(TCATADSAMSU14_NUGET_LIB ${TCATADSAMS_NUGET_PATH}/lib/x64)
    elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(TCATADSAMSU14_NUGET_BIN ${TCATADSAMS_NUGET_PATH}/bin/x86)
        set(TCATADSAMSU14_NUGET_LIB ${TCATADSAMS_NUGET_PATH}/lib/x86)
    endif()

        find_file(TCATADSAMS_LIBRARY
            NAMES
                TCATAdsAmsU14.dll
            HINTS
                ${TCATADSAMS_LIBDIR}
                $ENV{TCATADSAMS_LIBDIR}
            PATHS
                /usr/lib
	            /opt/lib
	            /usr/local/lib
	            /opt/local/lib
                ${TCATADSAMSU14_NUGET_BIN}
        )

        find_library(TCATADSAMS_LIBRARY_LIB
            NAMES
                TCATAdsAmsU14.lib
            HINTS
                ${TCATADSAMS_LIBDIR}
                $ENV{TCATADSAMS_LIBDIR}
            PATHS
                /usr/lib
	            /opt/lib
	            /usr/local/lib
	            /opt/local/lib
                ${TCATADSAMSU14_NUGET_LIB}
        )

    else()

        find_library(TCATADSAMS_LIBRARY
        NAMES
            TCATAdsAms
        HINTS
            ${TCATADSAMS_LIBDIR}
            $ENV{TCATADSAMS_LIBDIR}
        PATHS
            /usr/lib
	        /opt/lib
	        /usr/local/lib
	        /opt/local/lib
            ${TWINCAT_RUNTIME_PATH}
        )

    endif()
    
    set(TCATADSAMS_LIBRARIES ${TCATADSAMS_LIBRARY})
    set(TCATADSAMS_LIB_LIBRARIES ${TCATADSAMS_LIBRARY_LIB})
    set(TCATADSAMS_INCLUDE_DIRS ${TCATADSAMS_INCLUDE_DIR})

    include(FindPackageHandleStandardArgs)

    if(WIN32)
        find_package_handle_standard_args(TCATAdsAms TCATADSAMS_INCLUDE_DIR TCATADSAMS_LIBRARY TCATADSAMS_LIBRARY_LIB)
    else()
        find_package_handle_standard_args(TCATAdsAms TCATADSAMS_INCLUDE_DIR TCATADSAMS_LIBRARY)
    endif()

endif()

if(NOT TARGET TCATAdsAms)

    add_library(TCATAdsAms SHARED IMPORTED)

    if(WIN32)

        set_target_properties(TCATAdsAms PROPERTIES
	        INTERFACE_INCLUDE_DIRECTORIES "${TCATADSAMS_INCLUDE_DIRS}"
            IMPORTED_IMPLIB "${TCATADSAMS_LIB_LIBRARIES}"
            IMPORTED_LOCATION "${TCATADSAMS_LIBRARIES}"
        )

    else()

        set_target_properties(TCATAdsAms PROPERTIES
	        INTERFACE_INCLUDE_DIRECTORIES "${TCATADSAMS_INCLUDE_DIRS}"
            IMPORTED_LOCATION "${TCATADSAMS_LIBRARIES}"
            IMPORTED_SONAME "libTCATAdsAms.so"
        )

    endif()

endif()