if (TCPALDRVIF_LIBRARIES AND TCPALDRVIF_INCLUDE_DIRS)
    set(TCPALDRVIF_FOUND TRUE)

else()
    if (TWINCATSDK AND (EXISTS ${TWINCATSDK}/Include/platform/TcOS))
        set(TWINCATSDK_INCLUDE_TCOS "${TWINCATSDK}/Include/platform/TcOS")
    endif()

    find_path(TCPALDRVIF_INCLUDE_DIR
        NAMES
            TcPalDrvIf.h
		HINTS
            ${TCPALDRVIF_INCDIR}
            $ENV{TCPALDRVIF_INCDIR}
        PATHS
            /usr/include
	        /opt/include
			/usr/local/include
			/opt/local/include
			${TWINCATSDK_INCLUDE_TCOS}
    )

    find_library(TCPALDRVIF_LIBRARY
        NAMES
            TcPalDrvIf
		HINTS
            ${TCPALDRVIF_LIBDIR}
            $ENV{TCPALDRVIF_LIBDIR}
        PATHS
            /usr/lib
	        /opt/lib
	        /usr/local/lib
	        /opt/local/lib
             ${TWINCAT_RUNTIME_PATH}
    )

	set(TCPALDRVIF_INCLUDE_DIRS ${TCPALDRVIF_INCLUDE_DIR})
    set(TCPALDRVIF_LIBRARIES ${TCPALDRVIF_LIBRARY})

    include(FindPackageHandleStandardArgs)
    find_package_handle_standard_args(TcPalDrvIf TCPALDRVIF_INCLUDE_DIR TCPALDRVIF_LIBRARY)

endif()

if(NOT TARGET TcPalDrvIf)

    add_library(TcPalDrvIf SHARED IMPORTED)

    set_target_properties(TcPalDrvIf PROPERTIES
	    INTERFACE_INCLUDE_DIRECTORIES "${TCPALDRVIF_INCLUDE_DIRS}"
	    IMPORTED_LOCATION "${TCPALDRVIF_LIBRARIES}"
        IMPORTED_SONAME "libTcPalDrvIf.so"
    )

endif()